package org.bdware.sc.registry;

import com.google.gson.JsonObject;
import org.bdware.sc.ContractProcess;
import org.bdware.sc.boundry.JavaScriptEntry;
import org.bdware.sc.engine.JSONTool;
import wrp.jdk.nashorn.api.scripting.NashornScriptEngine;
import wrp.jdk.nashorn.api.scripting.ScriptObjectMirror;
import wrp.jdk.nashorn.internal.runtime.PropertyMap;
import wrp.jdk.nashorn.internal.runtime.ScriptFunction;
import wrp.jdk.nashorn.internal.scripts.JO;

public class RuleExecutor {
    private static int executeCode;
    private static String executeMsg;

    public static Object executeRule(ScriptObjectMirror som) {
        executeCode = 0;
        executeMsg = "success";
        JsonObject jo = JSONTool.convertMirrorToJson(som).getAsJsonObject();
        Object val = som.get("localDataSample");
        JsonObject rule = jo.get("mapRule").getAsJsonObject();
        JO ret = new JO(PropertyMap.newMap());
        for (String str : rule.keySet()) {
            ret.put(str, getMapResult(val, rule.get(str).getAsString()), false);
        }
        return ret;
    }

    //{"localDataSample":{"owner":"abcdef","size":"1234"},"mapRule":{"所有者":"${val.owner}","大小":"${val.size*1000}","偏移过的大小":"${edp(val.size,30.0)}" }}
    private static Object getMapResult(Object val, String fun) {
        try {
            NashornScriptEngine engine = ContractProcess.instance.engine.engine;
            if (fun.matches("\\$\\{.*\\}")) {
                fun = "function(val){ return " + fun.substring(2);
            }
            ScriptObjectMirror function = (ScriptObjectMirror) engine.eval(fun);
            function.compileScriptFunction();
            return JavaScriptEntry.executeFunction((ScriptFunction) function.getScriptObject(), val);
        } catch (Exception e) {
            e.printStackTrace();
            //TODO GREP....
            executeCode = 1;
            executeMsg = e.getMessage();
            return "exception:" + e.getMessage();
        }
    }

    public static int getLastExecuteStatus() {
        return executeCode;
    }
    public static String getLastExecuteMsg() {
        return executeMsg;
    }

}
