package org.bdware.datanet.searchengine;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import org.bdware.sc.ContractProcess;
import org.bdware.sc.engine.JSONTool;

import wrp.jdk.nashorn.api.scripting.ScriptObjectMirror;
import wrp.jdk.nashorn.api.scripting.ScriptUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.lucene.queryparser.classic.ParseException;

import javax.script.Invocable;
import javax.script.ScriptException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class SearchEngine{

    private final Logger LOGGER = LogManager.getLogger(SearchEngine.class);
    public MetaIndex metaIndex;
    public  SearchEngine(String Dirname){
        metaIndex=new MetaIndex(Dirname);
    }
    public  SearchEngine(){
        metaIndex=new MetaIndex();
    }


    public static SearchEngine createObj(String Dirname){
        return new SearchEngine(Dirname);
    }
    public static SearchEngine createObj(){
        return new SearchEngine();
    }

    public  String test(){return "success";}

    //params:
    //String type,String keyword,String count,String offset
    //String type,String keyword
    public String search(ScriptObjectMirror so){

        if(JSONTool.convertMirrorToJson(so).isJsonObject()){
            JsonObject jo=JSONTool.convertMirrorToJson(so).getAsJsonObject();
            System.out.println("search:  "+jo);
            if(jo.get("count")==null) jo.addProperty("count",10);
            if(jo.get("offset")==null) jo.addProperty("offset",0);
            return metaIndex.search(jo);
        }
        return "failed";
    }



    //根据时间范围查询 from ：to
    public String searchByRange(ScriptObjectMirror so){

        if(JSONTool.convertMirrorToJson(so).isJsonObject()){
            JsonObject jo=JSONTool.convertMirrorToJson(so).getAsJsonObject();
            if(jo.get("count")==null) jo.addProperty("count",10);
            if(jo.get("offset")==null) jo.addProperty("offset",0);
            return metaIndex.searchByRange(jo);
        }
        return "failed";
    }
    public String search(String type,String keyword,int count,int offset){
        JsonObject jo =new JsonObject();
        jo.addProperty("type",type);
        jo.addProperty("keyword",keyword);
        jo.addProperty("offset",offset);
        jo.addProperty("count",count);
        return metaIndex.search(jo);
    }
    public String search(String type,String keyword,String count,String offset){
        JsonObject jo =new JsonObject();
        jo.addProperty("type",type);
        jo.addProperty("keyword",keyword);
        jo.addProperty("offset",offset);
        jo.addProperty("count",count);
        return metaIndex.search(jo);
    }

    /*
    {"params":[{"type":"doid","ketword":"DBRepo"},{"type":"name","ketword":"xxx"}],"count":10,"offset":0}
     */
    public String searchByMultiTag(ScriptObjectMirror so){
        JsonElement je=JSONTool.convertMirrorToJson(so);
        JsonObject jo =je.getAsJsonObject();
        return metaIndex.searchByMultiTag(jo);
    }



    //{"doid":"xxx"}
    public String delete(ScriptObjectMirror so){

        if(JSONTool.convertMirrorToJson(so).isJsonObject()){
            JsonObject jo=JSONTool.convertMirrorToJson(so).getAsJsonObject();
            if(jo.get("doId")==null) return  "failed";
            else{
                 metaIndex.deleteRepo(jo.get("doId").getAsString());
                 return "success";
            }
        }
        return "failed";
    }
    public String delete(String doId){
        metaIndex.deleteRepo(doId);
        return "success";
    }

    public String search(String type, String keyword){
        JsonObject jo =new JsonObject();
        jo.addProperty("type",type);
        jo.addProperty("keyword",keyword);
        jo.addProperty("offset",0);
        jo.addProperty("count",10);
        return metaIndex.search(jo);
    }



    public int count(){
        return 0;
    }

    //一个do或者一个do数组
    public String update(ScriptObjectMirror so) throws IOException, ParseException {
        JsonElement je=JSONTool.convertMirrorToJson(so);
//        if(je.isJsonArray()){
//            List<DoMeta> list=new ArrayList<>();
//            for(JsonElement s : je.getAsJsonArray()) {
//                DoMeta r = new DoMeta(s.getAsJsonObject());
//                list.add(r);
//            }
//            metaIndex.updateRepoList(list);
//            return "success";
//        }
        if(je.isJsonObject()){

            DoMeta r=new DoMeta(je.getAsJsonObject());
            metaIndex.updateRepo(r);
            return "success";
        }
        else return "failed";
    }
    public String testScriptObjectMirror(ScriptObjectMirror so) throws IOException, ParseException {
        //JsonObject jo = (JsonObject) ScriptUtils.convert(so, JsonObject.class);
        JsonElement je=JSONTool.convertMirrorToJson(so);
        System.out.println(so.toString());
        System.out.println(so.getClass());
        System.out.println(je.getClass());
        System.out.println(je.toString());
        return "success";
    }
    public void addFunction(String function){
        try{
            ContractProcess.instance.engine.compileFunction(function,false);
            //ContractProcess.instance.engine.invokeFunction(function,args);

            //ContractProcess.instance.engine
        }catch (ScriptException e){
            e.printStackTrace();
        }
    }


//    public String updateList(JsonArray ja) throws IOException, ParseException {
//        List<RepoMeta> list=new ArrayList<>();
//        for(JsonElement s : ja.getAsJsonArray()){
//            RepoMeta r=new RepoMeta(s.getAsJsonObject());
//            list.add(r);
//        }
//        metaIndex.updateRepoList(list);
//        return "success";
//    }
}