import com.google.gson.JsonObject;
import org.apache.log4j.Logger;
import org.bdware.doip.audit.EndpointConfig;
import org.bdware.doip.audit.client.AuditIrpClient;
import org.bdware.doip.audit.config.FileStorage;
import org.bdware.irp.exception.IrpClientException;
import org.bdware.irp.stateinfo.StateInfoBase;
import org.junit.Before;
import org.junit.Test;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

public class GenerateDO {
    static Logger LOGGER = Logger.getLogger(GenerateDO.class);
    AuditIrpClient client;
    JsonObject otherConfig;

    @Before
    public void init() throws FileNotFoundException {
        FileStorage fs = new FileStorage("./input/auditrepo.json");
        EndpointConfig config = fs.loadAsEndpointConfig();
        config.repoName = null;
        otherConfig = fs.load();
        client = new AuditIrpClient(config);
    }

    @Test
    public void test() throws Exception {
        FileOutputStream fout = new FileOutputStream("./input/doi.txt",true);
        PrintStream ps = new PrintStream(fout);
        StateInfoBase base = new StateInfoBase();
        base.handleValues = new JsonObject();
        base.handleValues.addProperty("repoId", otherConfig.get("targetRepo").getAsString());
        base.handleValues.addProperty("timestamp", System.currentTimeMillis());
        try {
            String doid = client.register(base);
            if (doid != null) ps.println(doid);
            String format = "http://%s/SCIDE/SCManager?action=executeContract&contractID=SearchEngine&operation=testAddDo&arg=";
            String argStr = "{\"doId\":\"%s\",\"name\":\"repofile\",\"type\":\"text\",\"description\":\"这是一个模拟DO\",\"owner\":\"xx省yy市zz部门\",\"createTime\":%d}";
            format += argStr;
            String seURI = otherConfig.get("seURI").getAsString();
            long createTime = System.currentTimeMillis();
            long l = (long) (Math.random() * 1000D * 3600D * 24D);
            String data = String.format(format, seURI, doid, createTime - l);
            System.out.println(data);
        } catch (IrpClientException e) {
            e.printStackTrace();
        }
        fout.close();
        ps.close();
    }
}
